export interface IRenderFunction<T = any> {
    (container: Element | DocumentFragment | ShadowRoot, template: T): any;
}
export declare abstract class AbstractElement<T = any> extends HTMLElement {
    static attributes: {
        [x: string]: string;
    };
    private connected;
    protected attr: {
        [x: string]: string;
    };
    private _state;
    protected state: any;
    static readonly observedAttributes: string[];
    constructor(renderFunc: IRenderFunction<T>, shadow?: boolean, mode?: 'open' | 'closed');
    connectedCallback(): void;
    attributeChangedCallback(name: any, oldValue: any, newValue: any): void;
    forceUpdate(): void;
    private _attach;
    abstract render(): T;
}
