"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var AbstractElement = (function (_super) {
    __extends(AbstractElement, _super);
    function AbstractElement(renderFunc, shadow, mode) {
        if (shadow === void 0) { shadow = false; }
        if (mode === void 0) { mode = 'open'; }
        var _this = _super.call(this) || this;
        _this.connected = false;
        _this.attr = {};
        var attach = function (container) {
            if (_this.connected) {
                renderFunc(container, _this.render());
            }
        };
        if (shadow) {
            _this._attach = attach.bind(null, _this.attachShadow({ mode: mode }));
        }
        else {
            _this._attach = attach.bind(null, _this);
        }
        return _this;
    }
    Object.defineProperty(AbstractElement.prototype, "state", {
        get: function () {
            return this._state;
        },
        set: function (newState) {
            this._state = newState || this.state;
            this._attach();
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(AbstractElement, "observedAttributes", {
        get: function () {
            var _this = this;
            return Object.keys(this.attributes).map(function (key) { return _this.attributes[key]; });
        },
        enumerable: true,
        configurable: true
    });
    AbstractElement.prototype.connectedCallback = function () {
        this.connected = true;
        this._attach();
    };
    AbstractElement.prototype.attributeChangedCallback = function (name, oldValue, newValue) {
        if (oldValue !== newValue) {
            if (this.attr[name] !== newValue) {
                this.attr[name] = newValue;
            }
            for (var _i = 0, _a = Object.entries(this.constructor['attributes']); _i < _a.length; _i++) {
                var _b = _a[_i], attrProp = _b[0], attrKey = _b[1];
                if (attrKey === name && this[attrProp] !== newValue) {
                    this[attrProp] = newValue;
                    break;
                }
            }
            this._attach();
        }
    };
    AbstractElement.prototype.forceUpdate = function () {
        this._attach();
    };
    AbstractElement.prototype._attach = function () { };
    AbstractElement.attributes = {};
    return AbstractElement;
}(HTMLElement));
exports.AbstractElement = AbstractElement;
//# sourceMappingURL=abstract-element.js.map