"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
var abstract_element_1 = require("./abstract-element");
exports.AbstractElement = abstract_element_1.AbstractElement;
function Define(nameTag) {
    return function (originalConstructor) {
        try {
            customElements.define(nameTag, originalConstructor);
        }
        catch (error) {
            console.warn(error);
        }
    };
}
exports.Define = Define;
function state() {
    return function (target, key, descriptor) {
        makePropertyMapper(target, key, function (value) { return value; }, descriptor);
    };
}
exports.state = state;
function attr(name) {
    return function (target, key, descriptor) {
        var _a;
        var attributes = Reflect.get(target.constructor, 'attributes');
        Reflect.defineProperty(target.constructor, 'attributes', {
            value: __assign({}, attributes, (_a = {}, _a[key] = name, _a)),
            enumerable: true,
            writable: true
        });
    };
}
exports.attr = attr;
function makePropertyMapper(prototype, key, mapper, descriptor) {
    if (descriptor) {
        var setter_1 = descriptor.set || function () { };
        descriptor.set = function (val) {
            setter_1.apply(this, [val]);
            this.forceUpdate();
        };
    }
    else {
        var values_1 = new Map();
        Reflect.defineProperty(prototype, key, {
            set: function (firstValue) {
                Reflect.defineProperty(this, key, {
                    get: function () {
                        return values_1.get(this);
                    },
                    set: function (value) {
                        values_1.set(this, mapper(value));
                        this.forceUpdate();
                    },
                    enumerable: true,
                });
                this[key] = firstValue;
            },
            enumerable: true,
            configurable: true,
        });
    }
}
//# sourceMappingURL=index.js.map